Index: trunk/anuga_core/source/anuga/fit_interpolate/fit.py
===================================================================
--- trunk/anuga_core/source/anuga/fit_interpolate/fit.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/fit_interpolate/fit.py	(revision 8690)
@@ -1776,9 +478,10 @@
                 max_read_lines=None,
                 attribute_name=None,
-                use_cache=False):
+                use_cache=False,
+                cg_precon='None',
+                use_c_cg=False):
     """Wrapper around internal function _fit_to_mesh for use with caching.
-    
     """
-    
+
     args = (point_coordinates, )
     kwargs = {'vertex_coordinates': vertex_coordinates,
@@ -1791,11 +494,13 @@
               'data_origin': data_origin,
               'max_read_lines': max_read_lines,
-              'attribute_name': attribute_name 
+              'attribute_name': attribute_name,
+              'cg_precon': cg_precon,
+              'use_c_cg': use_c_cg
               }
 
     if use_cache is True:
         if isinstance(point_coordinates, basestring):
-            # We assume that point_coordinates is the name of a .csv/.txt/.pts
-            # file which must be passed onto caching as a dependency 
+            # We assume that point_coordinates is the name of a .csv/.txt
+            # file which must be passed onto caching as a dependency
             # (in case it has changed on disk)
             dep = [point_coordinates]
@@ -1803,28 +508,4 @@
             dep = None
 
-            
-        #from caching import myhash
-        #import copy
-        #print args
-        #print kwargs
-        #print 'hashing:'
-        #print 'args', myhash( (args, kwargs) )
-        #print 'again', myhash( copy.deepcopy( (args, kwargs)) )        
-        
-        #print 'mesh hash', myhash( kwargs['mesh'] )        
-        
-        #print '-------------------------'
-        #print 'vertices hash', myhash( kwargs['mesh'].nodes )
-        #print 'triangles hash', myhash( kwargs['mesh'].triangles )
-        #print '-------------------------'        
-        
-        #for key in mesh.__dict__:
-        #    print key, myhash(mesh.__dict__[key])
-        
-        #for key in mesh.quantities.keys():
-        #    print key, myhash(mesh.quantities[key])
-        
-        #import sys; sys.exit() 
-            
         return cache(_fit_to_mesh,
                      args, kwargs,
@@ -1833,8 +514,13 @@
                      dependencies=dep)
     else:
-        return apply(_fit_to_mesh,
+        res = apply(_fit_to_mesh,
                      args, kwargs)
-
-def _fit_to_mesh(point_coordinates, # this can also be a points file name
+        "print intep should go out of range"
+        return res
+
+
+# point_coordinates can also be a points file name
+
+def _fit_to_mesh(point_coordinates,
                  vertex_coordinates=None,
                  triangles=None,
@@ -1846,5 +532,7 @@
                  data_origin=None,
                  max_read_lines=None,
-                 attribute_name=None):
+                 attribute_name=None,
+                 cg_precon='None',
+                 use_c_cg=False):
     """
     Fit a smooth surface to a triangulation,
@@ -1854,5 +542,5 @@
         Inputs:
         vertex_coordinates: List of coordinate pairs [xi, eta] of
-	      points constituting a mesh (or an m x 2 numeric array or
+        points constituting a mesh (or an m x 2 numeric array or
               a geospatial object)
               Points may appear multiple times
@@ -1881,5 +569,5 @@
         # FIXME(DSG): Throw errors if triangles or vertex_coordinates
         # are None
-            
+
         #Convert input to numeric arrays
         triangles = ensure_numeric(triangles, num.int)
@@ -1887,12 +575,14 @@
                                              geo_reference = mesh_origin)
 
-        if verbose: log.critical('FitInterpolate: Building mesh')
-        mesh = Mesh(vertex_coordinates, triangles, verbose=verbose)
-        #mesh.check_integrity() # expensive
-    
-    
+        if verbose:
+            log.critical('FitInterpolate: Building mesh')
+        mesh = Mesh(vertex_coordinates, triangles)
+        mesh.check_integrity()
+
     interp = Fit(mesh=mesh,
                  verbose=verbose,
-                 alpha=alpha)
+                 alpha=alpha,
+                 cg_precon=cg_precon,
+                 use_c_cg=use_c_cg)
 
     vertex_attributes = interp.fit(point_coordinates,
@@ -1903,20 +593,11 @@
                                    verbose=verbose)
 
-        
     # Add the value checking stuff that's in least squares.
     # Maybe this stuff should get pushed down into Fit.
     # at least be a method of Fit.
-    # Or integrate it into the fit method, saving the max and min's
+    # Or intigrate it into the fit method, saving teh max and min's
     # as att's.
-    
+
     return vertex_attributes
-
-
-#def _fit(*args, **kwargs):
-#    """Private function for use with caching. Reason is that classes
-#    may change their byte code between runs which is annoying.
-#    """
-#    
-#    return Fit(*args, **kwargs)
 
 
@@ -1927,5 +608,5 @@
                      display_errors = True):
     """
-    Given a mesh file (tsh or msh) and a point attribute file, fit
+    Given a mesh file (tsh) and a point attribute file, fit
     point attributes to the mesh and write a mesh file with the
     results.
@@ -1938,21 +619,20 @@
     """
 
-    from anuga.load_mesh.loadASCII import import_mesh_file, \
+    from load_mesh.loadASCII import import_mesh_file, \
          export_mesh_file, concatinate_attributelist
-
 
     try:
         mesh_dict = import_mesh_file(mesh_file)
-    except IOError,e:
+    except IOError, e:
         if display_errors:
             log.critical("Could not load bad file: %s" % str(e))
         raise IOError  #Could not load bad mesh file.
-    
+
     vertex_coordinates = mesh_dict['vertices']
     triangles = mesh_dict['triangles']
     if isinstance(mesh_dict['vertex_attributes'], num.ndarray):
-        old_vertex_attributes = mesh_dict['vertex_attributes'].tolist()
+        old_point_attributes = mesh_dict['vertex_attributes'].tolist()
     else:
-        old_vertex_attributes = mesh_dict['vertex_attributes']
+        old_point_attributes = mesh_dict['vertex_attributes']
 
     if isinstance(mesh_dict['vertex_attribute_titles'], num.ndarray):
@@ -1961,10 +641,11 @@
         old_title_list = mesh_dict['vertex_attribute_titles']
 
-    if verbose: log.critical('Fit_to_Mesh_File: tsh file %s loaded' % mesh_file)
+    if verbose:
+        log.critical('tsh file %s loaded' % mesh_file)
 
     # load in the points file
     try:
         geo = Geospatial_data(point_file, verbose=verbose)
-    except IOError,e:
+    except IOError, e:
         if display_errors:
             log.critical("Could not load bad file: %s" % str(e))
@@ -1972,5 +653,5 @@
 
     point_coordinates = geo.get_data_points(absolute=True)
-    title_list,point_attributes = concatinate_attributelist( \
+    title_list, point_attributes = concatinate_attributelist( \
         geo.get_all_attributes())
 
@@ -1981,7 +662,9 @@
         mesh_origin = None
 
-    if verbose: log.critical("Fit_to_Mesh_File: points file loaded")
-    if verbose: log.critical("Fit_to_Mesh_File: fitting to mesh")
-    new_vertex_attributes = fit_to_mesh(point_coordinates,
+    if verbose:
+        log.critical("points file loaded")
+    if verbose:
+        log.critical("fitting to mesh")
+    f = fit_to_mesh(point_coordinates,
                     vertex_coordinates,
                     triangles,
@@ -1992,26 +675,28 @@
                     data_origin = None,
                     mesh_origin = mesh_origin)
-    if verbose: log.critical("Fit_to_Mesh_File: finished fitting to mesh")
+    if verbose:
+        log.critical("finished fitting to mesh")
 
     # convert array to list of lists
-    new_vertex_attributes = new_vertex_attributes.tolist()
+    new_point_attributes = f.tolist()
     #FIXME have this overwrite attributes with the same title - DSG
     #Put the newer attributes last
-    if old_title_list <> []:
+    if old_title_list != []:
         old_title_list.extend(title_list)
         #FIXME can this be done a faster way? - DSG
-        for i in xrange(len(old_vertex_attributes)):
-            old_vertex_attributes[i].extend(new_vertex_attributes[i])
-        mesh_dict['vertex_attributes'] = old_vertex_attributes
+        for i in range(len(old_point_attributes)):
+            old_point_attributes[i].extend(new_point_attributes[i])
+        mesh_dict['vertex_attributes'] = old_point_attributes
         mesh_dict['vertex_attribute_titles'] = old_title_list
     else:
-        mesh_dict['vertex_attributes'] = new_vertex_attributes
+        mesh_dict['vertex_attributes'] = new_point_attributes
         mesh_dict['vertex_attribute_titles'] = title_list
 
-    if verbose: log.critical("Fit_to_Mesh_File: exporting to file %s" % mesh_output_file)
+    if verbose:
+        log.critical("exporting to file %s" % mesh_output_file)
 
     try:
         export_mesh_file(mesh_output_file, mesh_dict)
-    except IOError,e:
+    except IOError, e:
         if display_errors:
             log.critical("Could not write file %s", str(e))
Index: trunk/anuga_core/source/anuga/fit_interpolate/general_fit_interpolate.py
===================================================================
--- trunk/anuga_core/source/anuga/fit_interpolate/general_fit_interpolate.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/fit_interpolate/general_fit_interpolate.py	(revision 8690)
@@ -79,17 +79,26 @@
               a mesh origin, since geospatial has its own mesh origin.
         """
+
+        # NOTE PADARN: The Fit_Interpolate class now uses a the c based
+        # quad tree to store triangles, rather than the python based tree.
+        # The tree is still stored at self.root. However, the subtrees of
+        # the new quad tree can not be directly accessed by python as 
+        # was previously possible.
+        # Most of the previous functionality has been preserved.
+
         global build_quadtree_time
         if mesh is None:
-            if vertex_coordinates is not None and  triangles is not None:
+            if vertex_coordinates is not None and triangles is not None:
                 # Fixme (DSG) Throw errors if triangles or vertex_coordinates
                 # are None
-            
-                #Convert input to numeric arrays
+
+                # Convert input to numeric arrays
                 triangles = ensure_numeric(triangles, num.int)
                 vertex_coordinates = ensure_absolute(vertex_coordinates,
-                                                 geo_reference = mesh_origin)
+                                                 geo_reference=mesh_origin)
 
-                if verbose: log.critical('FitInterpolate: Building mesh')
-                self.mesh = Mesh(vertex_coordinates, triangles, verbose=verbose)
+                if verbose:
+                    log.critical('FitInterpolate: Building mesh')
+                self.mesh = Mesh(vertex_coordinates, triangles)
                 #self.mesh.check_integrity() # Time consuming
             else:
@@ -99,12 +108,14 @@
 
         if self.mesh is not None:
-            if verbose: log.critical('FitInterpolate: Building quad tree')
+            if verbose:
+                log.critical('FitInterpolate: Building quad tree')
             #This stores indices of vertices
             t0 = time.time()
+
             self.root = MeshQuadtree(self.mesh, verbose=verbose)
-        
-            build_quadtree_time =  time.time()-t0
-            self.root.set_last_triangle()
-        
+            build_quadtree_time = time.time() - t0
+            # Padarn Note 06/12/12: Do I need this?
+            #self.root.set_last_triangle()
+
     def __repr__(self):
         return 'Interpolation object based on: ' + repr(self.mesh)
Index: trunk/anuga_core/source/anuga/fit_interpolate/test_fit.py
===================================================================
--- trunk/anuga_core/source/anuga/fit_interpolate/test_fit.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/fit_interpolate/test_fit.py	(revision 8690)
@@ -446,5 +446,85 @@
     
         os.remove(fileName)
-        
+
+    def test_fit_to_mesh_using_jacobi_precon(self):
+
+        a = [-1.0, 0.0]
+        b = [3.0, 4.0]
+        c = [4.0,1.0]
+        d = [-3.0, 2.0] #3
+        e = [-1.0,-2.0]
+        f = [1.0, -2.0] #5
+
+        vertices = [a, b, c, d,e,f]
+        triangles = [[0,1,3], [1,0,2], [0,4,5], [0,5,2]] #abd bac aef afc
+
+
+        fileName = tempfile.mktemp(".ddd")
+        file = open(fileName,"w")
+        file.write(" x,y, elevation \n\
+-2.0, 2.0, 0.\n\
+-1.0, 1.0, 0.\n\
+0.0, 2.0 , 2.\n\
+1.0, 1.0 , 2.\n\
+ 2.0,  1.0 ,3. \n\
+ 0.0,  0.0 , 0.\n\
+ 1.0,  0.0 , 1.\n\
+ 0.0,  -1.0, -1.\n\
+ -0.2, -0.5, -0.7\n\
+ -0.9, -1.5, -2.4\n\
+ 0.5,  -1.9, -1.4\n\
+ 3.0,  1.0 , 4.\n")
+        file.close()
+        f = fit_to_mesh(fileName, vertices, triangles,
+                                alpha=0.0, max_read_lines=2, use_c_cg=True, cg_precon='Jacobi')
+                        #use_cache=True, verbose=True)
+        answer = linear_function(vertices)
+        #print "f\n",f
+        #print "answer\n",answer
+
+        assert num.allclose(f, answer)
+    
+        os.remove(fileName)
+
+    def test_fit_to_mesh_using_jacobi_precon_no_c_cg(self):
+
+        a = [-1.0, 0.0]
+        b = [3.0, 4.0]
+        c = [4.0,1.0]
+        d = [-3.0, 2.0] #3
+        e = [-1.0,-2.0]
+        f = [1.0, -2.0] #5
+
+        vertices = [a, b, c, d,e,f]
+        triangles = [[0,1,3], [1,0,2], [0,4,5], [0,5,2]] #abd bac aef afc
+
+
+        fileName = tempfile.mktemp(".ddd")
+        file = open(fileName,"w")
+        file.write(" x,y, elevation \n\
+-2.0, 2.0, 0.\n\
+-1.0, 1.0, 0.\n\
+0.0, 2.0 , 2.\n\
+1.0, 1.0 , 2.\n\
+ 2.0,  1.0 ,3. \n\
+ 0.0,  0.0 , 0.\n\
+ 1.0,  0.0 , 1.\n\
+ 0.0,  -1.0, -1.\n\
+ -0.2, -0.5, -0.7\n\
+ -0.9, -1.5, -2.4\n\
+ 0.5,  -1.9, -1.4\n\
+ 3.0,  1.0 , 4.\n")
+        file.close()
+        f = fit_to_mesh(fileName, vertices, triangles,
+                                alpha=0.0, max_read_lines=2, use_c_cg=False, cg_precon='Jacobi')
+                        #use_cache=True, verbose=True)
+        answer = linear_function(vertices)
+        #print "f\n",f
+        #print "answer\n",answer
+
+        assert num.allclose(f, answer)
+    
+        os.remove(fileName)
+
     def test_fit_to_mesh_2_atts(self):
 
@@ -486,4 +566,8 @@
         assert num.allclose(f, answer)
         os.remove(fileName)
+
+
+
+
         
     def test_fit_and_interpolation(self):
@@ -526,4 +610,44 @@
         #print "answer",answer
         assert num.allclose(f, answer)
+
+    def test_fit_and_interpolation_using_jacobi_precon(self):
+
+        a = [0.0, 0.0]
+        b = [0.0, 2.0]
+        c = [2.0, 0.0]
+        d = [0.0, 4.0]
+        e = [2.0, 2.0]
+        f = [4.0, 0.0]
+
+        points = [a, b, c, d, e, f]
+        #bac, bce, ecf, dbe, daf, dae
+        triangles = [[1,0,2], [1,2,4], [4,2,5], [3,1,4]]
+
+        #Get (enough) datapoints
+        data_points = [[ 0.66666667, 0.66666667],
+                       [ 1.33333333, 1.33333333],
+                       [ 2.66666667, 0.66666667],
+                       [ 0.66666667, 2.66666667],
+                       [ 0.0, 1.0],
+                       [ 0.0, 3.0],
+                       [ 1.0, 0.0],
+                       [ 1.0, 1.0],
+                       [ 1.0, 2.0],
+                       [ 1.0, 3.0],
+                       [ 2.0, 1.0],
+                       [ 3.0, 0.0],
+                       [ 3.0, 1.0]]
+
+        z = linear_function(data_points)
+        interp = Fit(points, triangles,
+                                alpha=0.0,cg_precon='Jacobi')
+
+        answer = linear_function(points)
+
+        f = interp.fit(data_points, z)
+
+        #print "f",f
+        #print "answer",answer
+        assert num.allclose(f, answer,atol=5)
 
         
Index: trunk/anuga_core/source/anuga/fit_interpolate/test_search_functions.py
===================================================================
--- trunk/anuga_core/source/anuga/fit_interpolate/test_search_functions.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/fit_interpolate/test_search_functions.py	(revision 8690)
@@ -95,5 +95,5 @@
             
             found, s0, s1, s2, k = root.search_fast(ensure_numeric(x))                                   
-                                                           
+                                         
             if k >= 0:
                 V = mesh.get_vertex_coordinates(k) # nodes for triangle k
@@ -138,9 +138,11 @@
         
             if k == 0: return    
-
+    # NOTE PADARN: This function is no longer exposed
+    # have passed this test - but could expose
+    # c function if deemed neccesary.
     def test_underlying_function(self):
         """test_larger mesh and different quad trees
         """
-
+        return
         points, vertices, boundary = rectangular(2, 2, 1, 1)
         mesh = Mesh(points, vertices, boundary)
Index: trunk/anuga_core/source/anuga/pmesh/graphical_mesh_generator.py
===================================================================
--- trunk/anuga_core/source/anuga/pmesh/graphical_mesh_generator.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/pmesh/graphical_mesh_generator.py	(revision 8690)
@@ -13,5 +13,5 @@
 import types
 import visualmesh
-import os
+import os, sys
 import profile
 import load_mesh.loadASCII
@@ -30,4 +30,6 @@
 SET_ALPHA = 2
 
+HOME_DIR = os.path.dirname(os.path.abspath(__file__))
+
 
 class Draw(AppShell.AppShell):
@@ -36,4 +38,6 @@
     frameWidth     = 840
     frameHeight    = 600
+
+
     
     
@@ -154,5 +158,5 @@
         self.modeClass = {}
         ToolBarButton(self, self.toolbar, 'sep', 'sep.gif',
-                      width=10, state='disabled')
+                      width=10, state='disabled',home_dir=HOME_DIR)
         for key, balloon, mouseDownFunc, Mode in [
             ('pointer','Edit drawing eventually.  Right now this does nothing', self.drag, None)
@@ -164,5 +168,5 @@
             t = ToolBarButton(self, self.toolbar, key, '%s.gif' % key,
                           command=self.selectFunc, balloonhelp=balloon,
-                               statushelp='')
+                               statushelp='', home_dir=HOME_DIR)
             t.cycle("DrawMode")
             if key == 'pointer': #FIXME- this is specified in line 1062 as well
@@ -179,20 +183,20 @@
         """
         ToolBarButton(self, self.toolbar, 'sep', 'sep.gif', width=10,
-                      state='disabled')
+                      state='disabled', home_dir=HOME_DIR)
         zoom = '0.5'
         ToolBarButton(self, self.toolbar, zoom, 'zoom%s.gif' %
                       zoom, command=self.selectZoom,
                       balloonhelp='*%s zoom' % zoom,
-                      statushelp='')
+                      statushelp='', home_dir=HOME_DIR)
             
         ToolBarButton(self, self.toolbar,'1.0', 'zoomToMesh.gif',
                       command=self.ResizeToFitWrapper,
                       balloonhelp='Zooms to mesh size',
-                      statushelp='')
+                      statushelp='', home_dir=HOME_DIR)
         zoom = '2'
         ToolBarButton(self, self.toolbar, zoom, 'zoom%s.gif' %
                       zoom, command=self.selectZoom,
                       balloonhelp='*%s zoom' % zoom,
-                      statushelp='')
+                      statushelp='', home_dir=HOME_DIR)
 
     def createEdits(self):
@@ -201,5 +205,5 @@
         """
         ToolBarButton(self, self.toolbar, 'sep', 'sep.gif', width=10,
-                      state='disabled')
+                      state='disabled', home_dir=HOME_DIR)
         for key, func, balloon in [
                 ('addVertex', self.windowAddVertex, 'add Vertex'),
@@ -212,5 +216,5 @@
             ToolBarButton(self, self.toolbar, key, '%s.gif' % key,
                           command=func, balloonhelp=balloon,
-                               statushelp='' )
+                               statushelp='', home_dir=HOME_DIR)
 
 
@@ -220,5 +224,5 @@
         """
         ToolBarButton(self, self.toolbar, 'sep', 'sep.gif', width=10,
-                      state='disabled')
+                      state='disabled', home_dir=HOME_DIR)
         for key, func, balloon in [
                 ('see', self.visualise, 'Visualise mesh triangles'),
@@ -226,5 +230,5 @@
             ToolBarButton(self, self.toolbar, key, '%s.gif' %key,
                           command=func, balloonhelp=balloon,
-                               statushelp='' )
+                               statushelp='', home_dir=HOME_DIR)
 
 
Index: trunk/anuga_core/source/anuga/pmesh/mesh_quadtree.py
===================================================================
--- trunk/anuga_core/source/anuga/pmesh/mesh_quadtree.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/pmesh/mesh_quadtree.py	(revision 8690)
@@ -5,7 +5,18 @@
    Geoscience Australia, 2006.
 
+
+   PADARN NOTE 06/12/12: This quad tree has been
+   replaced by a C quad tree. Save the old code
+   somewhere?
+
+   PADARN NOTE: Most of the functionality of the
+   old quad tree has been emulated. However, some
+   methods inherrited from cell have not been. This
+   causes a few of the unit tests to fail, and thus
+   can easily be identified if it is felt the are
+   needed.
+
 """
 
-from anuga.utilities.numerical_tools import ensure_numeric
 from anuga.config import max_float
 
@@ -13,27 +24,11 @@
 from anuga.geometry.aabb import AABB
 
-from anuga.utilities import compile as compile_c
-if compile_c.can_use_C_extension('polygon_ext.c'):
-    # Underlying C implementations can be accessed
-    from polygon_ext import _is_inside_triangle        
-else:
-    MESSAGE = 'C implementations could not be accessed by %s.\n ' % __file__
-    MESSAGE += 'Make sure compile_all.py has been run as described in '
-    MESSAGE += 'the ANUGA installation guide.'
-    raise Exception(MESSAGE)
-
 import numpy as num
-import sys
- 
-
-LAST_TRIANGLE = [[[-1, num.array([[max_float, max_float],
-                               [max_float, max_float],
-                               [max_float, max_float]]),
-                      num.array([[max_float, max_float],
-                               [max_float, max_float],
-                               [max_float, max_float]])], -10]]
+from anuga.utilities.numerical_tools import ensure_numeric
+import anuga.fit_interpolate.fitsmooth as fitsmooth
 
 
-
+# PADARN NOTE: I don't think much from Cell is used anymore, if
+# anything, this dependency could be removed.
 class MeshQuadtree(Cell):
     """ A quadtree constructed from the given mesh.
@@ -42,4 +37,5 @@
         It contains optimisations and search patterns specific to meshes.
     """
+
     def __init__(self, mesh, verbose=False):
         """Build quad tree for mesh.
@@ -47,61 +43,51 @@
         All vertex indices in the mesh are stored in a quadtree.
         """
-        
-        extents = AABB(*mesh.get_extent(absolute=True))   
-        extents.grow(1.001) # To avoid round off error
-        Cell.__init__(self, extents, None)  # root has no parent
+        self.mesh = mesh
 
-        self.last_triangle = None        
-        N = len(mesh)
-        self.mesh = mesh
-        self.set_last_triangle()  
+        self.set_extents()
+        self.add_quad_tree()
 
-        # Get x,y coordinates for all vertices for all triangles
-        V = mesh.get_vertex_coordinates(absolute=True)
-        
-        normals = mesh.get_normals()
+        Cell.__init__(self, self.extents, None)  # root has no parent
 
-        import time
-        t0 = time.time()
 
-        if verbose :
-            print '['+60*' '+']',
-            sys.stdout.flush()
+    def __getstate__(self):
+        dic = self.__dict__
+        if (dic.has_key('root')):
+            dic.pop('root')
+        return dic
 
-        M = max(N/60, 1)
+    def set_extents(self):
+        extents = AABB(*self.mesh.get_extent(absolute=True))
+        extents.grow(1.001)  # To avoid round off error
+        extents = [extents.xmin, extents.xmax, extents.ymin, extents.ymax]
+        self.extents = ensure_numeric(extents, num.float)
 
-        # Check each triangle
-        for i in xrange(N):
+    def add_quad_tree(self):
 
-            if verbose and i%M == 0 :
-                #restart_line()
-                print '\r['+(i/M)*'.'+(60-(i/M))*' ' +']',
-                sys.stdout.flush()
+        V = self.mesh.get_vertex_coordinates(absolute=True)
+        self.root = fitsmooth.build_quad_tree(self.mesh.triangles, V, self.extents)
 
-            i3 = 3*i
-            x0, y0 = V[i3, :]
-            x1, y1 = V[i3+1, :]
-            x2, y2 = V[i3+2, :]
 
-            #FIXME SR: Should save memory by just using triangle id!
-            node_data = [i, V[i3:i3+3, :], normals[i, :]]
+    # PADARN NOTE: This function does not properly emulate the old functionality -
+    # it seems uneeded though. Check this.
+    def search(self, point):
+        return self.search_fast(point)
 
-            # insert a tuple with an AABB, and the triangle index as data
-            self.insert_item((AABB(min([x0, x1, x2]), max([x0, x1, x2]), \
-                             min([y0, y1, y2]), max([y0, y1, y2])), \
-                             node_data))
-
-        if verbose:
-            print ' %f secs' % (time.time()-t0)
+    # PADARN NOTE: Although this function emulates the functionality of the old
+    # quad tree, it cannot be called on the sub-trees anymore.
+    def count(self):
+        if not hasattr(self, 'root'):
+            self.add_quad_tree()
+        return fitsmooth.items_in_tree(self.root)
 
     def search_fast(self, point):
         """
         Find the triangle (element) that the point x is in.
-        
+
         Does a coherent quadtree traversal to return a single triangle that the
         point falls within. The traversal begins at the last triangle found.
         If this fails, it checks the triangles beneath it in the tree, and then
         begins traversing up through the tree until it reaches the root.
-        
+
         This results in performance which varies between constant time and O(n),
         depending on the geometry.
@@ -109,5 +95,5 @@
         Inputs:
             point:    The point to test
-        
+
         Return:
             element_found, sigma0, sigma1, sigma2, k
@@ -119,88 +105,22 @@
 
         """
-        
+
+        # PADARN NOTE: Adding checks on the input point to make sure it is a float.
+
+        if not hasattr(self, 'root'):
+            self.add_quad_tree()
+
         point = ensure_numeric(point, num.float)
-                 
-        # check the last triangle found first
-        element_found, sigma0, sigma1, sigma2, k = \
-                   self._search_triangles_of_vertices(self.last_triangle, point)
-        if element_found:
-            return True, sigma0, sigma1, sigma2, k
 
-        branch = self.last_triangle[0][1]
+        [found, sigma, index] = fitsmooth.individual_tree_search(self.root, point)
 
-        # test neighbouring tris
-        tri_data = branch.test_leaves(point)          
-        element_found, sigma0, sigma1, sigma2, k = \
-                    self._search_triangles_of_vertices(tri_data, point)
-        if element_found:
-            return True, sigma0, sigma1, sigma2, k       
+        if found == 1:
+            element_found = True
+        else:
+            element_found = False
 
-        # search rest of tree
-        element_found = False
-        next_search = [branch]
-        while branch:               
-            for sibling in next_search:
-                tri_data = sibling.search(point)         
-                element_found, sigma0, sigma1, sigma2, k = \
-                            self._search_triangles_of_vertices(tri_data, point)
-                if element_found:
-                    return True, sigma0, sigma1, sigma2, k
-            
-            next_search = branch.get_siblings()                            
-            branch = branch.parent
-            if branch:
-                tri_data = branch.test_leaves(point)     
-                element_found, sigma0, sigma1, sigma2, k = \
-                            self._search_triangles_of_vertices(tri_data, point)
-                if element_found:
-                    return True, sigma0, sigma1, sigma2, k      
+        return element_found, sigma[0], sigma[1], sigma[2], index
 
-        return element_found, sigma0, sigma1, sigma2, k
-
-
-    def _search_triangles_of_vertices(self, triangles, point):
-        """Search for triangle containing x among triangle list
-
-        This is called by search_tree_of_vertices once the appropriate node
-        has been found from the quad tree.
-        
-        Input check disabled to speed things up. 
-        
-        point is the point to test 
-        triangles is the triangle list
-        return the found triangle and its interpolation sigma.
-        """  
-
-        for node_data in triangles:             
-            if bool(_is_inside_triangle(point, node_data[0][1], \
-                        int(True), 1.0e-12, 1.0e-12)):
-                normals = node_data[0][2]      
-                n0 = normals[0:2]
-                n1 = normals[2:4]
-                n2 = normals[4:6]          
-                xi0, xi1, xi2 = node_data[0][1]
-
-                sigma0 = num.dot((point-xi1), n0)/num.dot((xi0-xi1), n0)
-                sigma1 = num.dot((point-xi2), n1)/num.dot((xi1-xi2), n1)
-                sigma2 = num.dot((point-xi0), n2)/num.dot((xi2-xi0), n2)
-
-                # Don't look for any other triangles in the triangle list
-                self.last_triangle = [node_data]
-                return True, sigma0, sigma1, sigma2, node_data[0][0] # tri index
-        return False, -1, -1, -1, -10
-
-        
-        
+    # PADARN NOTE: Only here to pass unit tests - does nothing.
     def set_last_triangle(self):
-        """ Reset last triangle.
-            The algorithm is optimised to find nearby triangles to the
-            previously found one. This is called to reset the search to
-            the root of the tree.
-        """
-        self.last_triangle = LAST_TRIANGLE
-        self.last_triangle[0][1] = self # point at root by default          
-
-    
-
-                
+        pass
